<template>
  <div id="app">
    <AimsHeader :locale="$i18n.locale" @changeLocale="changeLocale" />
    <div class="container-fluid">
      <b-row class="iconRow" align-v="center">
        <b-col align-h="start" class="text-start">
          <ActivityActions
            :application-profile="selectedApplicationProfile"
            :definition="definition"
            @makeEditable="makeEditable"
            @openEditModal="openEditModal"
            @textDefinitionUpdate="textDefinitionUpdate"
            @updateApplicationProfile="updateApplicationProfile"
            @updateToken="updateToken"
          />
        </b-col>
        <b-col align-h="center" class="text-center">
          <NavigationActions />
        </b-col>
        <b-col align-h="end" class="text-end">
          <SubmissionActions
            :application-profile="selectedApplicationProfile"
            :complete-application-profile="completeApplicationProfile"
            :current-definition="currentDefinition"
            :definition="definition"
            :readonly="readonly"
            @stateChange="stateChange"
            @storedApplicationProfiles="storedApplicationProfiles"
            @updateDefinition="updateDefinition"
          />
        </b-col>
      </b-row>
      <router-view
        :application-profile="selectedApplicationProfile"
        :complete-application-profile="completeApplicationProfile"
        :current-application-profile="currentApplicationProfile"
        :current-definition="currentDefinition"
        :current-readonly="currentReadonly"
        :definition="definition"
        :interactive="interactive"
        :querying-application-profile="queryingApplicationProfile"
        :readonly="readonly"
        :selected-property="selectedProperty"
        :session-stored-application-profiles="sessionStoredApplicationProfiles"
        :token="token"
        @addVocabularyTerm="addVocabularyTerm"
        @emptyApplicationProfile="emptyApplicationProfile"
        @openEditModal="openEditModal"
        @removeProperty="removeProperty"
        @selectApplicationProfile="selectApplicationProfile"
        @selectProperty="selectProperty"
        @switchDisplayedApplicationProfile="switchDisplayedApplicationProfile"
        @switchInteractivity="switchInteractivity"
        @textDefinitionUpdate="textDefinitionUpdate"
        @updateDefinition="updateDefinition"
      />
      <EditModal
        :application-profile="currentApplicationProfile"
        :definition="currentDefinition"
        label-prefix="edit"
        ok-label-key="Continue"
        :open="editModalOpen"
        :readonly="currentReadonly"
        @close="closeEditModal"
        @save="editAP"
        @stateChange="stateChange"
      />
      <NotificationToast />
    </div>
    <CustomFooter
      v-if="$options.components && $options.components['CustomFooter']"
    />
  </div>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import ApplicationProfileImpl from "@/classes/ApplicationProfileImpl";
import type VocabularyTerm from "@/types/vocabulary-term";
import State from "@/types/state";
import type { Dataset, Quad_Object, Quad_Subject } from "@rdfjs/types";

import factory from "rdf-ext";

import { defineComponent } from "vue";

import serviceProvider from "@/util/service-providers/service-provider";

import { parseRDFDefinition } from "@/util/basicLinkedData";

import {
  addVocabularyTermToDataset,
  parseApplicationProfile,
  prefixes,
  removeVocabularyTermFromDataset,
  setApplicationProfileBasedOnDataset,
} from "@/util/linkedData";

import type DatasetExt from "rdf-ext/lib/Dataset";

import { useMainStore } from "@/store";

import EmptyComponent from "@/components/Layout/EmptyComponent.vue";
const CustomFooter = serviceProvider.uiElements.CustomFooter ?? EmptyComponent;

export default defineComponent({
  name: "App",
  components: {
    CustomFooter,
  },
  props: {},
  setup() {
    const mainStore = useMainStore();

    return { mainStore };
  },
  data() {
    return {
      displayedApplicationProfile: "",
      completeApplicationProfile: {
        definition: factory.dataset() as unknown as Dataset,
        inheritedParts: {} as Record<
          string,
          {
            applicationProfile: ApplicationProfile;
            definition: Dataset;
          }
        >,
      },
      definition: factory.dataset() as unknown as Dataset,
      editModalOpen: false,
      interactive: true,
      queryingApplicationProfile: false,
      queryingApplicationProfiles: [] as string[],
      readonly: true,
      selectedApplicationProfile: new ApplicationProfileImpl("", "", {
        definition: "[]",
        mimeType: "application/ld+json",
      }) as ApplicationProfile,
      selectedProperty: factory.blankNode() as Quad_Subject,
      sessionStoredApplicationProfiles: 0,
      token: serviceProvider.getToken(),
    };
  },
  computed: {
    applicationProfileChosen(): boolean {
      return (
        this.displayedApplicationProfile !== "" &&
        Object.keys(this.completeApplicationProfile.inheritedParts).includes(
          this.displayedApplicationProfile,
        )
      );
    },
    currentApplicationProfile(): ApplicationProfile {
      if (this.applicationProfileChosen) {
        return this.completeApplicationProfile.inheritedParts[
          this.displayedApplicationProfile
        ].applicationProfile;
      }
      return this.selectedApplicationProfile;
    },
    currentDefinition(): Dataset {
      if (this.applicationProfileChosen) {
        return this.completeApplicationProfile.inheritedParts[
          this.displayedApplicationProfile
        ].definition;
      }
      return this.definition;
    },
    currentReadonly(): boolean {
      return this.readonly || this.applicationProfileChosen;
    },
    toBeInheritedParts(): Quad_Object[] {
      return [
        ...this.completeApplicationProfile.definition.match(
          null,
          factory.namedNode(prefixes.owl + "imports"),
          null,
        ),
      ].map((quad) => quad.object);
    },
  },
  watch: {
    definition() {
      const previousImports = [
        ...this.completeApplicationProfile.definition.match(
          factory.namedNode(this.selectedApplicationProfile.base_url),
          factory.namedNode(prefixes.owl + "imports"),
          null,
        ),
      ].map((quad) => quad.object.value);

      this.completeApplicationProfile.definition = (
        this.definition as unknown as DatasetExt
      ).clone() as unknown as Dataset;

      const newImports = [
        ...this.completeApplicationProfile.definition.match(
          factory.namedNode(this.selectedApplicationProfile.base_url),
          factory.namedNode(prefixes.owl + "imports"),
          null,
        ),
      ].map((quad) => quad.object.value);

      const newImportsSorted = [...newImports].sort();
      const importsHaveNotChanged =
        previousImports.length === newImports.length &&
        [...previousImports].sort().every((value, index) => {
          return value === newImportsSorted[index];
        });

      if (importsHaveNotChanged) {
        for (const inheritedPart of Object.values(
          this.completeApplicationProfile.inheritedParts,
        )) {
          (this.completeApplicationProfile
            .definition as unknown as DatasetExt) = (
            this.completeApplicationProfile.definition as unknown as DatasetExt
          ).merge(inheritedPart.definition as unknown as DatasetExt);
        }
      } else {
        this.completeApplicationProfile.inheritedParts = {};
      }
    },
    async selectedApplicationProfile() {
      this.selectedProperty = factory.blankNode();
      this.queryingApplicationProfiles = [];
      this.displayedApplicationProfile = "";
      await this.setDefinition();
    },
    async toBeInheritedParts() {
      for (const toBeInheritedPart of this.toBeInheritedParts) {
        if (
          !Object.keys(this.completeApplicationProfile.inheritedParts).includes(
            toBeInheritedPart.value,
          ) &&
          !this.queryingApplicationProfiles.includes(toBeInheritedPart.value)
        ) {
          // Async get AP and add to definition
          this.queryingApplicationProfiles.push(toBeInheritedPart.value);
          try {
            const inheritedAP = await this.getApplicationProfile(
              toBeInheritedPart.value,
            );
            const definitionOfInheritedAp =
              await parseApplicationProfile(inheritedAP);
            (this.completeApplicationProfile
              .definition as unknown as DatasetExt) = (
              this.completeApplicationProfile
                .definition as unknown as DatasetExt
            ).merge(definitionOfInheritedAp as unknown as DatasetExt);
            // Trigger reactivity
            const newInheritedParts = {
              ...this.completeApplicationProfile.inheritedParts,
            };
            newInheritedParts[toBeInheritedPart.value] = {
              applicationProfile: inheritedAP,
              definition: definitionOfInheritedAp,
            };
            this.completeApplicationProfile.inheritedParts = newInheritedParts;
          } catch {
            console.error(
              "Application Profile " +
                toBeInheritedPart.value +
                " cannot be found!",
            );
            // Trigger reactivity
            const newInheritedParts = {
              ...this.completeApplicationProfile.inheritedParts,
            };
            newInheritedParts[toBeInheritedPart.value] = {
              applicationProfile: new ApplicationProfileImpl(
                "",
                toBeInheritedPart.value,
              ),
              definition: factory.dataset() as unknown as Dataset,
            };
            this.completeApplicationProfile.inheritedParts = newInheritedParts;
          }
          if (
            this.queryingApplicationProfiles.includes(toBeInheritedPart.value)
          ) {
            this.queryingApplicationProfiles.splice(
              this.queryingApplicationProfiles.indexOf(toBeInheritedPart.value),
              1,
            );
          }
        }
      }
    },
  },
  mounted() {
    this.$watch(
      () => this.$route.query,
      (toQuery, previousQuery) => {
        if (
          toQuery["applicationProfile"] &&
          toQuery["applicationProfile"] !==
            previousQuery["applicationProfile"] &&
          !Array.isArray(toQuery["applicationProfile"]) &&
          !Array.isArray(toQuery["accessToken"]) &&
          toQuery["applicationProfile"] !==
            this.selectedApplicationProfile.base_url
        ) {
          this.selectApplicationProfile(
            new ApplicationProfileImpl("", toQuery["applicationProfile"], {
              accessToken:
                toQuery["accessToken"] ??
                this.mainStore.getAccessToken(toQuery["applicationProfile"]),
            }),
          );
        } else if (
          !toQuery["applicationProfile"] &&
          this.selectedApplicationProfile.base_url
        ) {
          this.$router.push({
            query: {
              applicationProfile: this.selectedApplicationProfile.base_url,
            },
          });
        }
      },
    );
    const predefinedAp = this.$route.query["applicationProfile"];
    let accessToken = this.$route.query["accessToken"];
    if (
      predefinedAp &&
      !Array.isArray(predefinedAp) &&
      !Array.isArray(accessToken)
    ) {
      accessToken =
        accessToken ?? this.mainStore.getAccessToken(predefinedAp) ?? "";
      this.selectApplicationProfile(
        new ApplicationProfileImpl("", predefinedAp, { accessToken }),
      );
    }
  },
  methods: {
    addVocabularyTerm(vocabularyTerm: VocabularyTerm) {
      const changeHappened = addVocabularyTermToDataset(
        vocabularyTerm,
        this.selectedApplicationProfile,
        this.definition,
      );
      if (changeHappened) {
        this.updateDefinition();
      }
    },
    closeEditModal() {
      this.editModalOpen = false;
    },
    changeLocale(locale: string) {
      this.$i18n.locale = locale;
    },
    cloneApplicationProfile() {
      this.selectedApplicationProfile = new ApplicationProfileImpl(
        this.selectedApplicationProfile.name,
        this.selectedApplicationProfile.base_url,
        {
          definition: this.selectedApplicationProfile.definition ?? "[]",
          mimeType: this.selectedApplicationProfile.mimeType,
        },
      );
    },
    editAP() {
      this.updateDefinition();
      this.editModalOpen = false;
    },
    emptyApplicationProfile() {
      this.selectedApplicationProfile = new ApplicationProfileImpl("", "", {
        definition: "[]",
        mimeType: "application/ld+json",
      });
      this.definition = factory.dataset() as unknown as Dataset;
      this.selectedApplicationProfile.definition =
        this.definition.toCanonical();
      this.selectedApplicationProfile.mimeType = "application/n-quads";
      this.readonly = true;
    },
    async getApplicationProfile(
      baseUrl: string,
      accessToken?: string | null,
    ): Promise<ApplicationProfile> {
      try {
        return await serviceProvider.apiConnection.getApplicationProfile(
          baseUrl,
          accessToken,
        );
      } catch {
        return this.mainStore.getApplicationProfile(baseUrl);
      }
    },
    makeEditable() {
      this.readonly = false;
    },
    openEditModal() {
      this.editModalOpen = true;
    },
    removeProperty(property: Quad_Subject) {
      removeVocabularyTermFromDataset(property, this.definition);
      this.updateDefinition();
    },
    async selectApplicationProfile(
      selectedApplicationProfile: ApplicationProfile,
    ) {
      if (
        this.$route.query["applicationProfile"] !==
        selectedApplicationProfile.base_url
      ) {
        this.$router.push({
          query: { applicationProfile: selectedApplicationProfile.base_url },
        });
      }
      if (selectedApplicationProfile.definition === undefined) {
        this.queryingApplicationProfile = true;
        try {
          this.selectedApplicationProfile = await this.getApplicationProfile(
            selectedApplicationProfile.base_url,
            selectedApplicationProfile.accessToken,
          );
          this.selectedApplicationProfile.accessToken =
            selectedApplicationProfile.accessToken;
        } finally {
          this.queryingApplicationProfile = false;
        }
      } else {
        this.selectedApplicationProfile = selectedApplicationProfile;
      }
      if (this.selectedApplicationProfile.state === State.DRAFT) {
        this.makeEditable();
      } else {
        this.readonly = true;
      }
    },
    selectProperty(property: Quad_Subject) {
      this.selectedProperty = property;
    },
    async setDefinition() {
      this.definition = await parseApplicationProfile(
        this.selectedApplicationProfile,
      );
      this.completeApplicationProfile.inheritedParts = {};
    },
    stateChange(state: State) {
      this.selectedApplicationProfile.state = state;
    },
    storedApplicationProfiles(
      storedApplicationProfile: ApplicationProfile | void,
    ) {
      if (storedApplicationProfile) {
        this.selectedApplicationProfile.state = storedApplicationProfile.state;
        if (
          storedApplicationProfile.accessToken &&
          storedApplicationProfile.accessToken !== "-1"
        ) {
          this.selectedApplicationProfile.accessToken =
            storedApplicationProfile.accessToken;
        }
      }
      this.readonly = this.selectedApplicationProfile.state !== State.DRAFT;
      this.sessionStoredApplicationProfiles++;
    },
    async switchDisplayedApplicationProfile(
      displayedApplicationProfile: string,
    ) {
      this.displayedApplicationProfile = displayedApplicationProfile;
      if (
        !this.applicationProfileChosen &&
        this.displayedApplicationProfile !==
          this.selectedApplicationProfile.base_url
      ) {
        await this.selectApplicationProfile(
          new ApplicationProfileImpl("", displayedApplicationProfile),
        );
      }
      this.$router.push({ name: "Editor" });
    },
    switchInteractivity() {
      this.interactive = !this.interactive;
    },
    async textDefinitionUpdate(
      textDefinition: string,
      mimeType = "application/n-quads",
    ) {
      this.definition = await parseRDFDefinition(
        textDefinition,
        mimeType,
        this.selectedApplicationProfile.base_url,
      );
      const oldBaseUrl = this.selectedApplicationProfile.base_url;
      this.selectedApplicationProfile =
        await setApplicationProfileBasedOnDataset(
          this.definition,
          this.$i18n.locale,
          oldBaseUrl,
        );
      this.updateDefinitionAfter();
    },
    updateApplicationProfile(
      applicationProfile: ApplicationProfile,
      definition?: Dataset,
    ) {
      this.selectedApplicationProfile = applicationProfile;
      this.updateDefinition(definition);
    },
    updateDefinition(definition?: Dataset) {
      // Force definition update
      this.definition = (
        (definition as unknown as DatasetExt) ??
        (this.definition as unknown as DatasetExt)
      ).clone() as unknown as Dataset;
      this.updateDefinitionAfter();
    },
    updateDefinitionAfter() {
      if (
        this.$route.query["applicationProfile"] !==
        this.selectedApplicationProfile.base_url
      ) {
        this.$router.push({
          query: {
            applicationProfile: this.selectedApplicationProfile.base_url,
          },
        });
      }

      this.mainStore.storeApplicationProfile(
        this.selectedApplicationProfile,
        this.definition,
      );
    },
    updateToken(token: string) {
      this.token = token;
    },
  },
});
</script>

<style>
#app {
  width: 100%;
  text-align: center;
}
.my-dropdown .dropdown-header {
  font-weight: bold;
  color: black;
}
.my-dropdown .dropdown-menu .dropdown-item {
  margin-left: 0.3rem;
}
.row.iconRow {
  margin-top: 0.4rem;
  margin-bottom: 0.4rem;
}
.iconRow .btn {
  margin: 0 3px;
}
.iconRow a {
  margin: 0 3px;
}
.cardRow {
  height: calc(100vh - 45px - 50px);
}
.cardRow .list-group {
  border-radius: 0.25rem;
  overflow-y: auto;
  overflow-x: hidden;
  /* Subject to change since different cards have different sizes for list-groups */
  max-height: 76vh;
}
.cardRow .list-group button.list-group-item-action,
.cardRow .list-group a.list-group-item-action {
  background: none;
  padding: 0.75rem 1.25rem;
  border: 1px solid rgba(0, 0, 0, 0.125);
}

.cardRow .list-group button.list-group-item.btn-danger {
  border: 1px solid rgba(0, 0, 0, 0.125);
  color: var(--bs-danger);
  background-color: var(--bs-body-bg);
}
.cardRow .list-group button.list-group-item.btn-danger.disabled {
  border: 1px solid rgba(0, 0, 0, 0.125);
  color: var(--bs-danger);
  background-color: var(--bs-secondary-bg-subtle);
}
.cardRow .list-group button.list-group-item.btn-danger:focus,
.cardRow .list-group button.list-group-item.btn-danger:hover {
  border: 1px solid rgba(0, 0, 0, 0.125);
  color: white;
  background-color: var(--bs-danger);
}

.cardRow .list-group button.list-group-item-action:focus,
.cardRow .list-group button.list-group-item-action:hover {
  z-index: 1;
  text-decoration: none;
  background-color: var(--bs-primary-bg-subtle);
  margin-top: 0px;
}
.cardRow .list-group button.list-group-item-action.active {
  z-index: 1;
  text-decoration: none;
  background-color: var(--bs-primary);
  border-color: var(--bs-primary);
  color: white;
  margin-top: 0px;
}
.b-tooltip .overflow-auto {
  overflow-y: hidden !important;
}
.apTooltip .tooltip-inner {
  max-width: 300px;
}
.no-overflow {
  overflow: hidden;
  text-overflow: ellipsis;
}
.no-overflow h5 {
  overflow: hidden;
  text-overflow: ellipsis;
}
#storeToast.toast:not(.showing):not(.show) {
  opacity: 1;
  display: block;
}
#storeFailedToast.toast:not(.showing):not(.show) {
  opacity: 1;
  display: block;
}
.toast-body {
  background-color: var(--bs-body-bg);
  color: var(--bs-body-color);
}
.toast.showing {
  opacity: 1;
}
:root {
  font-size: 16px !important;
}

.multiselect__select {
  border-radius: 10px;
  height: 100%;
  max-height: 36px;
}
.multiselect--disabled .multiselect__input,
.multiselect--disabled .multiselect__single,
.multiselect--disabled .multiselect__option,
.multiselect--disabled .multiselect__select,
.multiselect--disabled .multiselect__tags,
.multiselect--disabled .multiselect__placeholder {
  background-color: var(--bs-secondary-bg);
}
.form-control:disabled,
.form-select:disabled {
  color: var(--bs-secondary-color);
}

[data-bs-theme="dark"] .b-form-tags.focus {
  color: var(--bs-primary-text-emphasis);
  background-color: var(--bs-primary-bg-subtle);
}
[data-bs-theme="dark"] .v-select ul,
[data-bs-theme="dark"] .v-select .vs__selected-options,
[data-bs-theme="dark"] .v-select .vs__dropdown-toggle,
[data-bs-theme="dark"] .v-select .vs__search,
[data-bs-theme="dark"] .v-select .vs__actions,
[data-bs-theme="dark"] .v-select .vs__actions svg {
  background-color: var(--bs-body-bg);
}
[data-bs-theme="dark"] .v-select .vs__selected div {
  color: var(--bs-white);
}
[data-bs-theme="dark"] .multiselect {
  border-radius: 20px;
}
[data-bs-theme="dark"] .multiselect__tags {
  background-color: var(--bs-body-bg);
  border: var(--bs-border-width) solid var(--bs-border-color);
  color: var(--bs-body-color);
  border-radius: var(--bs-border-radius);
}
[data-bs-theme="dark"] .multiselect__content-wrapper {
  border: 1px solid var(--bs-border-color);
}
[data-bs-theme="dark"] .multiselect--disabled,
[data-bs-theme="dark"] .multiselect__input,
[data-bs-theme="dark"] .multiselect__single,
[data-bs-theme="dark"] .multiselect__option,
[data-bs-theme="dark"] .multiselect__select {
  background-color: var(--bs-body-bg);
  color: var(--bs-body-color);
}
[data-bs-theme="dark"] .multiselect__option--group {
  background-color: var(--bs-secondary-bg) !important;
  color: var(--bs-body-color);
}
[data-bs-theme="dark"] .multiselect__placeholder {
  background-color: var(--bs-body-bg);
  color: var(--bs-secondary-color) !important;
}
[data-bs-theme="dark"] .multiselect--disabled .multiselect__input,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__single,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__option,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__select,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__tags,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__placeholder {
  background-color: var(--bs-secondary-bg);
  color: var(--bs-body-color);
}
[data-bs-theme="dark"] a.text-primary,
[data-bs-theme="dark"] .h6.text-primary,
[data-bs-theme="dark"] .text-primary a {
  color: var(--bs-primary-text-emphasis) !important;
}
[data-bs-theme="dark"] .cardRow .list-group button.list-group-item-action,
[data-bs-theme="dark"] .cardRow .list-group a.list-group-item-action {
  border: 1px solid rgba(255, 255, 255, 0.125);
}
[data-bs-theme="dark"] .cardRow .list-group button.list-group-item.btn-danger {
  border: 1px solid rgba(255, 255, 255, 0.125);
}
[data-bs-theme="dark"]
  .cardRow
  .list-group
  button.list-group-item.btn-danger.disabled {
  border: 1px solid rgba(255, 255, 255, 0.125);
}
[data-bs-theme="dark"]
  .cardRow
  .list-group
  button.list-group-item.btn-danger:focus,
[data-bs-theme="dark"]
  .cardRow
  .list-group
  button.list-group-item.btn-danger:hover {
  border: 1px solid rgba(255, 255, 255, 0.125);
}
</style>
